<?php
/*
Plugin Name: Development Debug Backtraces
Description: Display debug backtraces for every error generated by PHP, in addition to the standard error outputs configured for your PHP installation. This includes E_ALL so might contain many more errors than you might expect. This is useful for finding and debugging issues during development, but could easily break your markup, and is not for users who are not editing code directly. Requires jQuery to be included with your theme.
Version: 0.2.1
Author: Storm Consultancy
Author URI: http://www.stormconsultancy.co.uk
License: GPL2
*/

/*  Copyright 2012 Storm Consultancy (email: dev@stormconsultancy.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

set_error_handler('error_backtrace');

function error_backtrace($errno, $errstr, $errfile, $errline, $errcontext) {
  if ($errno == E_STRICT) return false;
  echo '<br />';
  echo '<a href="#" onclick="jQuery(this).next().css(\'display\',\'block\'); jQuery(this).next().next().css(\'display\',\'block\'); jQuery(this).css(\'display\',\'none\'); return false;">Show Backtrace For Error</a>';
  echo '<a href="#" style="display:none" onclick="jQuery(this).prev().css(\'display\',\'block\'); jQuery(this).next().css(\'display\',\'none\'); jQuery(this).css(\'display\',\'none\'); return false;">Hide Backtrace</a>';
  echo '<div style="display:none; font-size: 10px; background-color: #F5F6CE; padding-left: 5px; padding-right: 5px; overflow: auto; border-radius: 5px;">';
  echo '<pre>';
  debug_print_backtrace();
  echo '</pre>';
  echo '</div>';
  return false;
}

?>
